//  iyv12prop.cpp
//
//	YV12 to YUY2 converter PropertyPages
//
//	Copyright (c)
//

#define WIN32_LEAN_AND_MEAN		// Windows wb_[gpĂȂO܂B
// Windows wb_[ t@C :
#include <windows.h>
#include <streams.h>
#include <initguid.h>
#include <commctrl.h>

#include "iyv12guids.h"
#include "iyv12prop.h"
#include "iyv12defs.h"
#include "resource.h"
#include "convf.h"

// -----------------------------------------

CUnknown * WINAPI Ciyv12Prop::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    Ciyv12Prop * pNewObject = new Ciyv12Prop(punk);
    if (pNewObject == NULL)
	{
        *phr = E_OUTOFMEMORY;
    }
    return pNewObject;
}


Ciyv12Prop::Ciyv12Prop(LPUNKNOWN pUnk) :
	CBasePropertyPage(NAME("IYV12Prop"), pUnk, IDD_IYV12Prop, IDS_IYV12Prop)
	,m_pIYV12(0)
{

}
void Ciyv12Prop::SetDirty(void)
{
	m_bDirty = TRUE;
	if (m_pPageSite)
    {
		m_pPageSite->OnStatusChange(PROPPAGESTATUS_DIRTY);
    }
}

HRESULT Ciyv12Prop::OnConnect(IUnknown *pUnk)
{
	if (pUnk == NULL)
    {
        return E_POINTER;
    }
    ASSERT(m_pIYV12 == NULL);

	HRESULT hr;
        // pUnk ŃtB^̃JX^ C^[tFCX₢킹B
    hr = pUnk->QueryInterface(IID_IIYV12,
             reinterpret_cast<void**>(&m_pIYV12));
    return hr;
}

HRESULT Ciyv12Prop::OnActivate(void)
{
    ASSERT(m_pIYV12 != NULL);
	// func select
	HRESULT hr = m_pIYV12->GetFuncN(&m_Val.nFunc);
	if (SUCCEEDED(hr)) {
		SendDlgItemMessage(m_Dlg, IDC_P1+m_Val.nFunc, BM_SETCHECK, BST_CHECKED, 0);
	}
	// field diff threshold
	SendDlgItemMessage(m_Dlg, IDC_FA_TH_FIELD, TBM_SETRANGE, 0, (LPARAM)MAKELONG(TH_MIN, TH_MAX));
	hr = m_pIYV12->GetFieldTH(&m_Val.thField);
	if (SUCCEEDED(hr)) {
		SendDlgItemMessage(m_Dlg, IDC_FA_TH_FIELD, TBM_SETPOS, 1, m_Val.thField);
	}
	// frame diff threshold
	SendDlgItemMessage(m_Dlg, IDC_FA_TH_FRAME, TBM_SETRANGE, 0, (LPARAM)MAKELONG(TH_MIN, TH_MAX));
	hr = m_pIYV12->GetFrameTH(&m_Val.thFrame);
	if (SUCCEEDED(hr)) {
		SendDlgItemMessage(m_Dlg, IDC_FA_TH_FRAME, TBM_SETPOS, 1, m_Val.thFrame);
	}
	// display mode
	hr = m_pIYV12->GetDispMode(&m_Val.dispmode);
	if (SUCCEEDED(hr)) {
		SendDlgItemMessage(m_Dlg, IDC_FA_HIDE+m_Val.dispmode, BM_SETCHECK, BST_CHECKED, 0);
	}
	
	m_NewVal = m_Val;

	return S_OK;
}

BOOL Ciyv12Prop::OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
	case WM_COMMAND:
		if(LOWORD(wParam)>=IDC_P1 && LOWORD(wParam)<IDC_P1+FUNC_N){
			m_NewVal.nFunc = wParam - IDC_P1;
			SetDirty();
			return (LRESULT) 1;
		}
		
		if(LOWORD(wParam)>=IDC_FA_HIDE && LOWORD(wParam)<=IDC_FA_FIELD){
			m_NewVal.dispmode = wParam - IDC_FA_HIDE;
			SetDirty();
			return (LRESULT) 1;
		}

		if(LOWORD(wParam)==IDC_FA_RESET){
			m_NewVal.thField  = m_Val.thField = TH_FIELD_DEFAULT;
			m_NewVal.thFrame  = m_Val.thFrame = TH_FRAME_DEFAULT;
			m_pIYV12->SetFieldTH(m_Val.thField);
			m_pIYV12->SetFrameTH(m_Val.thFrame);
			SendDlgItemMessage(m_Dlg, IDC_FA_TH_FRAME, TBM_SETPOS, 1, m_Val.thFrame);
			SendDlgItemMessage(m_Dlg, IDC_FA_TH_FIELD, TBM_SETPOS, 1, m_Val.thField);
			return (LRESULT) 1;
		}
		break;
	case WM_HSCROLL:
		// [U[XC_𓮂B
		switch(LOWORD(wParam))
		{
		case TB_PAGEDOWN:
		case SB_THUMBTRACK:
		case TB_PAGEUP:
			m_NewVal.thField = m_Val.thField = SendDlgItemMessage(m_Dlg, IDC_FA_TH_FIELD, TBM_GETPOS, 0, 0);
			m_NewVal.thFrame = m_Val.thFrame = SendDlgItemMessage(m_Dlg, IDC_FA_TH_FRAME, TBM_GETPOS, 0, 0);
			m_pIYV12->SetFieldTH(m_Val.thField);
			m_pIYV12->SetFrameTH(m_Val.thFrame);
		}
		return (LRESULT) 1;
	}

	// eNXɃbZ[WB
    return CBasePropertyPage::OnReceiveMessage(hwnd,uMsg,wParam,lParam);
}

HRESULT Ciyv12Prop::OnApplyChanges(void)
{
	m_Val = m_NewVal;
	m_pIYV12->SetFuncN(m_Val.nFunc);
	//m_pIYV12->SetFieldTH(m_Val.thField);
	//m_pIYV12->SetFrameTH(m_Val.thFrame);
	m_pIYV12->SetDispMode(m_Val.dispmode);
	return S_OK;
}

HRESULT Ciyv12Prop::OnDisconnect(void)
{
    if (m_pIYV12)
    {
		m_pIYV12->SetFuncN(m_Val.nFunc);
		//m_pIYV12->SetFieldTH(m_Val.thField);
		//m_pIYV12->SetFrameTH(m_Val.thFrame);
		m_pIYV12->SetDispMode(m_Val.dispmode);
		
		m_pIYV12->Release();
		m_pIYV12 = NULL;
	}
	return S_OK;
}




void LoadRegistryInfo(IYV12CONF *conf)
{
	HKEY hKey;
	DWORD size;
	LONG ret;
	RegOpenKeyEx(HWDI_REG_KEY, HWDI_REG_SUBKEY, 0, KEY_READ, &hKey);

	size=sizeof(conf->nFunc); 
	ret = RegQueryValueEx(hKey, "iyv12_func", NULL, NULL, (LPBYTE)&conf->nFunc, &size);
	if(ret != ERROR_SUCCESS || conf->nFunc < 0 || conf->nFunc >= FUNC_N){
		conf->nFunc = 0;
	}

	size=sizeof(conf->thField); 
	ret = RegQueryValueEx(hKey, "iyv12_field_th", NULL, NULL, (LPBYTE)&conf->thField, &size);
	if(ret != ERROR_SUCCESS || conf->thField < TH_MIN || conf->thField > TH_MAX){
		conf->thField = TH_FIELD_DEFAULT;
	}

	size=sizeof(conf->thFrame); 
	ret = RegQueryValueEx(hKey, "iyv12_frame_th", NULL, NULL, (LPBYTE)&conf->thFrame, &size);
	if(ret != ERROR_SUCCESS || conf->thFrame < TH_MIN || conf->thFrame > TH_MAX){
		conf->thFrame = TH_FRAME_DEFAULT;
	}

	size=sizeof(conf->dispmode); 
	ret = RegQueryValueEx(hKey, "iyv12_dispmode", NULL, NULL, (LPBYTE)&conf->dispmode, &size);
	if(ret != ERROR_SUCCESS || conf->dispmode < 0 || conf->dispmode > DISP_FIELD){ 
		conf->dispmode = 0;
	}

	RegCloseKey(hKey);
}

void SaveRegistryInfo(IYV12CONF conf)
{
	HKEY hKey;
	DWORD dispo;

	if (RegCreateKeyEx(
			HWDI_REG_KEY,
			HWDI_REG_SUBKEY,
			0,
			HWDI_REG_CLASS,
			REG_OPTION_NON_VOLATILE,
			KEY_WRITE,
			0, 
			&hKey, 
			&dispo) != ERROR_SUCCESS)
	{
		OutputDebugString("Couldn't create HWDI_REG_SUBKEY");
		return;
	}

	// check value
	if(conf.nFunc < 0 || conf.nFunc >= FUNC_N){
		conf.nFunc = 0;
	}
	if(conf.thField < TH_MIN || conf.thField > TH_MAX){
		conf.thField = TH_FIELD_DEFAULT;
	}
	if(conf.thFrame < TH_MIN || conf.thFrame > TH_MAX){
		conf.thFrame = TH_FRAME_DEFAULT;
	}
	if(conf.dispmode < 0 || conf.dispmode > DISP_FIELD){ 
		conf.dispmode = 0;
	}

	RegSetValueEx(hKey, "iyv12_func", 0, REG_DWORD, (LPBYTE)&conf.nFunc, sizeof(DWORD));
	RegSetValueEx(hKey, "iyv12_field_th", 0, REG_DWORD, (LPBYTE)&conf.thField, sizeof(DWORD));
	RegSetValueEx(hKey, "iyv12_frame_th", 0, REG_DWORD, (LPBYTE)&conf.thFrame, sizeof(DWORD));
	RegSetValueEx(hKey, "iyv12_dispmode", 0, REG_DWORD, (LPBYTE)&conf.dispmode, sizeof(DWORD));

	RegCloseKey(hKey);
}

